## openalpr 2.2.4

=== doc/requirements.txt ===
Babel==2.1.1
Jinja2==2.8
MarkupSafe==0.23
Pygments==2.0.2
Sphinx==1.3.1
alabaster==0.7.6
argparse==1.2.1
docutils==0.12
pytz==2015.7
six==1.10.0
snowballstemmer==1.2.0
sphinx-rtd-theme==0.1.9
wsgiref==0.1.2

=== src/CMakeLists.txt ===
project(src)

#set(CMAKE_BUILD_TYPE Debug)
cmake_minimum_required (VERSION 2.6)

# Set the OpenALPR version in cmake, and also add it as a DEFINE for the code to access
SET(OPENALPR_MAJOR_VERSION "2")
SET(OPENALPR_MINOR_VERSION "2")
SET(OPENALPR_PATCH_VERSION "4")
SET(OPENALPR_VERSION ${OPENALPR_MAJOR_VERSION}.${OPENALPR_MINOR_VERSION}.${OPENALPR_PATCH_VERSION})

add_definitions( -DOPENALPR_MAJOR_VERSION=${OPENALPR_MAJOR_VERSION})
add_definitions( -DOPENALPR_MINOR_VERSION=${OPENALPR_MINOR_VERSION})
add_definitions( -DOPENALPR_PATCH_VERSION=${OPENALPR_PATCH_VERSION})

SET(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake_modules/")

# TODO: switch to http://www.cmake.org/cmake/help/v2.8.5/cmake.html#module:GNUInstallDirs ?
IF (NOT CMAKE_INSTALL_SYSCONFDIR) 
  SET(CMAKE_INSTALL_SYSCONFDIR "/etc")
ENDIF()
IF (NOT CMAKE_INSTALL_VARDIR) 
  SET(CMAKE_INSTALL_VARDIR "${CMAKE_INSTALL_PREFIX}/var")
ENDIF()

IF ( NOT DEFINED WITH_DAEMON )
  SET(WITH_DAEMON ON)
ENDIF()

IF ( NOT DEFINED WITH_STATEDETECTION )
  SET(WITH_STATEDETECTION ON)
ENDIF()

if ( NOT DEFINED WITH_GPU_DETECTOR )
  SET(WITH_GPU_DETECTOR OFF)
ENDIF()

if ( NOT DEFINED WITH_TESTS )
  SET(WITH_TESTS ON)
ENDIF()

if ( NOT DEFINED WITH_BINDING_JAVA )
  SET(WITH_BINDING_JAVA ON)
ENDIF()

if ( NOT DEFINED WITH_BINDING_PYTHON )
  SET(WITH_BINDING_PYTHON ON)
ENDIF()

if ( NOT DEFINED WITH_BINDING_GO )
  SET(WITH_BINDING_GO ON)
ENDIF()

if ( NOT DEFINED WITH_UTILITIES )
  SET(WITH_UTILITIES ON)
ENDIF()

IF (WIN32 AND WITH_DAEMON) 
  MESSAGE(WARNING "Skipping alprd daemon installation, as it is not supported in Windows.")
  SET(WITH_DAEMON OFF)
ENDIF()

IF(Tesseract_FRAMEWORK_PATH AND Leptonica_FRAMEWORK_PATH) 
  MESSAGE(STATUS "Using Tesseract iOS framework: ${Tesseract_FRAMEWORK_PATH}")
  MESSAGE(STATUS "Using Leptonica iOS framework: ${Leptonica_FRAMEWORK_PATH}")
  # http://www.vtk.org/Wiki/CMake:HowToUseExistingOSXFrameworks
  SET(Tesseract_LIBRARIES "${Tesseract_FRAMEWORK_PATH};${Leptonica_FRAMEWORK_PATH}")
  SET(Tesseract_INCLUDE_DIRS "${Tesseract_FRAMEWORK_PATH}/Headers")
ELSE()
  FIND_PACKAGE( Tesseract REQUIRED )
ENDIF()

include_directories(${Tesseract_INCLUDE_DIRS})

IF(OpenCV_FRAMEWORK_PATH)
  MESSAGE(STATUS "Using OpenCV iOS framework: ${OpenCV_FRAMEWORK_PATH}")
  SET(OpenCV_INCLUDE_DIRS "${OpenCV_FRAMEWORK_PATH}/Headers")
  SET(OpenCV_LIBS ${OpenCV_FRAMEWORK_PATH})

  # OpenCV's released framework has this disabled, so we must too.
  # http://stackoverflow.com/a/32710441/868173
  SET(CMAKE_XCODE_ATTRIBUTE_ENABLE_BITCODE NO)
ELSE()
  # Discover OpenCV directory automatically
  find_path(OpenCV_DIR
    NAMES OpenCVConfig.cmake
    HINTS ${CMAKE_SOURCE_DIR}/../libraries/opencv/
    /storage/projects/alpr/libraries/opencv/
    )
  # Opencv Package
  FIND_PACKAGE( OpenCV REQUIRED )
ENDIF()

IF (${OpenCV_VERSION} VERSION_LESS 2.4.7)
	MESSAGE(FATAL_ERROR "OpenCV version is not compatible : ${OpenCV_VERSION}")
ENDIF()

include_directories(${OpenCV_INCLUDE_DIRS})

add_definitions( -DOPENCV_MAJOR_VERSION=${OpenCV_VERSION_MAJOR})


include_directories(./openalpr )

IF (WIN32)
	add_definitions( -DWINDOWS)
	add_definitions( -DNOMINMAX)

	# Extra linker dependencies for Windows
	SET (Tesseract_LIBRARIES
		${Tesseract_LIBRARIES}
		ws2_32.lib
	)
ELSE()

	SET (Extra_LIBS
		pthread
	)

ENDIF()


set(CMAKE_CSS_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} -Wall ")
if (NOT IOS)
  ADD_EXECUTABLE( alpr  main.cpp )
ENDIF()

if (WIN32) 
   SET(OPENALPR_LIB openalpr-static)
ELSE()
   SET(OPENALPR_LIB openalpr)
ENDIF()

IF (WITH_STATEDETECTION)
  SET(STATE_DETECTION_LIB statedetection)
  add_subdirectory(statedetection)
ELSE()
  SET(STATE_DETECTION_LIB "")
  add_definitions( -DSKIP_STATE_DETECTION=1 )
ENDIF()

if (NOT IOS)
  TARGET_LINK_LIBRARIES(alpr
    ${OPENALPR_LIB}
    ${STATE_DETECTION_LIB}
    support
    video
    ${OpenCV_LIBS}
    ${Tesseract_LIBRARIES}
    ${Extra_LIBS}
  )
ENDIF()


# Compile the alprd library on Unix-based OS
IF (WITH_DAEMON)
  ADD_EXECUTABLE( alprd  daemon.cpp daemon/beanstalk.c daemon/beanstalk.cc )

  FIND_PACKAGE( log4cplus REQUIRED )

  TARGET_LINK_LIBRARIES(alprd
      ${OPENALPR_LIB}
	  support
      video
	  curl
	  ${OpenCV_LIBS}
	  ${Tesseract_LIBRARIES}
	  ${log4cplus_LIBRARIES}
      ${Extra_LIBS}
    )
	
ENDIF()

if(WITH_UTILITIES)
add_subdirectory(misc_utilities)
ENDIF()

if (WITH_TESTS)  
add_subdirectory(tests)
ENDIF()

add_subdirectory(openalpr)
add_subdirectory(video)

if (WITH_BINDING_JAVA) 
add_subdirectory(bindings/java)
ENDIF()

if (WITH_BINDING_PYTHON)
add_subdirectory(bindings/python)
ENDIF()

if (WITH_BINDING_GO)
    set(OPENALPR_LIB_GO openalprgo)
    set(TAG_OPENALPR_LIB_GO "-l${OPENALPR_LIB_GO}")
    add_subdirectory(bindings/go)
ENDIF()

if (NOT IOS)
  install (TARGETS    alpr DESTINATION   ${CMAKE_INSTALL_PREFIX}/bin)
  install (FILES      ${CMAKE_SOURCE_DIR}/../doc/man/alpr.1 DESTINATION       ${CMAKE_INSTALL_PREFIX}/share/man/man1 COMPONENT doc)
ENDIF()
install (DIRECTORY  ${CMAKE_SOURCE_DIR}/../runtime_data DESTINATION         ${CMAKE_INSTALL_PREFIX}/share/openalpr)

# set runtime_data to reflect the current CMAKE_INSTALL_PREFIX
CONFIGURE_FILE(${CMAKE_SOURCE_DIR}/../config/openalpr.conf.in ${CMAKE_CURRENT_BINARY_DIR}/config/openalpr.conf)
install (FILES      ${CMAKE_CURRENT_BINARY_DIR}/config/openalpr.conf DESTINATION ${CMAKE_INSTALL_SYSCONFDIR}/openalpr/      COMPONENT config)

IF (WITH_DAEMON)
  install (TARGETS    alprd DESTINATION  ${CMAKE_INSTALL_PREFIX}/bin)
  install (FILES      ${CMAKE_SOURCE_DIR}/../config/alprd.conf DESTINATION    ${CMAKE_INSTALL_SYSCONFDIR}/openalpr      COMPONENT config)
ENDIF()


SET (CPACK_PACKAGE_VERSION ${OPENALPR_VERSION})
SET (CPACK_SET_DESTDIR "on")
SET (CPACK_GENERATOR "DEB;TGZ")
SET (CPACK_PACKAGE_NAME "openalpr")
SET (CPACK_INSTALL_CMAKE_PROJECTS "${CMAKE_SOURCE_DIR}/build;src;ALL;/")
SET (CPACK_CMAKE_GENERATOR "Unix Makefiles")

SET (CPACK_STRIP_FILES "1")
SET (CPACK_DEBIAN_PACKAGE_PRIORITY "optional")
SET (CPACK_DEBIAN_PACKAGE_SECTION "video")
SET (CPACK_DEBIAN_ARCHITECTURE ${CMAKE_SYSTEM_PROCESSOR})
SET (CPACK_DEBIAN_PACKAGE_DEPENDS "libc6 (>= 2.1.3), libgcc1 (>= 4.1.1), libtesseract3 (>= 3.0.3), libopencv-core2.4 (>= 2.4.8), libopencv-objdetect2.4 (>= 2.4.8), libopencv-highgui2.4 (>= 2.4.8), libopencv-imgproc2.4 (>= 2.4.8), libopencv-flann2.4 (>= 2.4.8), libopencv-features2d2.4 (>= 2.4.8), libopencv-video2.4 (>= 2.4.8), libopencv-gpu2.4 (>=2.4.8), liblog4cplus-1.0-4, libcurl3, beanstalkd")

SET (CPACK_RESOURCE_FILE_LICENSE "${CMAKE_SOURCE_DIR}/../LICENSE")
SET (CPACK_PACKAGE_DESCRIPTION "OpenALPR - Open Source Automatic License Plate Recognition")
SET (CPACK_PACKAGE_DESCRIPTION_SUMMARY "OpenALPR is an open source Automatic License Plate Recognition library written in C++.  The library analyzes images and identifies license plates. The output is the text representation of any license plate characters found in the image.  Check out a live online demo here: http://www.openalpr.com/demo.html" )
SET (CPACK_PACKAGE_CONTACT "Matt Hill <matt@ndu.com>")
SET (CPACK_PACKAGE_FILE_NAME "${CPACK_PACKAGE_NAME}_${CPACK_PACKAGE_VERSION}_${CPACK_DEBIAN_ARCHITECTURE}")

SET (CPACK_COMPONENTS_ALL Libraries ApplicationData)

INCLUDE(CPack)

# ----------------------------------------------------------------------------
# Uninstall target, for "make uninstall"
# http://www.cmake.org/Wiki/CMake_FAQ#Can_I_do_.22make_uninstall.22_with_CMake.3F
# ----------------------------------------------------------------------------
CONFIGURE_FILE(
  "${CMAKE_MODULE_PATH}/templates/cmake_uninstall.cmake.in"
  "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
  @ONLY)

ADD_CUSTOM_TARGET(uninstall COMMAND ${CMAKE_COMMAND} -P "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake")

=== src/openalpr/CMakeLists.txt ===



set(lpr_source_files
 alpr.cpp
 alpr_impl.cpp
 config.cpp
 detection/detector.cpp
 detection/detectorcpu.cpp
 detection/detectorcuda.cpp
 detection/detectorocl.cpp
 detection/detectorfactory.cpp
 detection/detectormorph.cpp
 licenseplatecandidate.cpp
 utility.cpp
 ocr.cpp
 postprocess/postprocess.cpp
 postprocess/regexrule.cpp
 binarize_wolf.cpp
 segmentation/charactersegmenter.cpp
 segmentation/histogram.cpp
 segmentation/histogramvertical.cpp
 segmentation/histogramhorizontal.cpp
 edges/edgefinder.cpp
 edges/platecorners.cpp
 edges/platelines.cpp
 edges/textlinecollection.cpp
 edges/scorekeeper.cpp
 colorfilter.cpp
 prewarp.cpp
 transformation.cpp
 textdetection/characteranalysis.cpp
 textdetection/platemask.cpp
 textdetection/textcontours.cpp
 textdetection/textline.cpp
 textdetection/linefinder.cpp
 pipeline_data.cpp
 cjson.c
 motiondetector.cpp
 result_aggregator.cpp
)

 

add_subdirectory(simpleini)
add_subdirectory(support)


add_library(openalpr-static 	STATIC ${lpr_source_files} )
add_library(openalpr 		SHARED ${lpr_source_files} )

set_target_properties(openalpr PROPERTIES SOVERSION ${OPENALPR_MAJOR_VERSION})

TARGET_LINK_LIBRARIES(openalpr
  support
  ${STATE_DETECTION_LIB}
  ${OpenCV_LIBS}
  ${Tesseract_LIBRARIES}
)


install (FILES   alpr.h     DESTINATION    ${CMAKE_INSTALL_PREFIX}/include)
install (TARGETS openalpr-static DESTINATION ${CMAKE_INSTALL_PREFIX}/lib)
install (TARGETS openalpr   DESTINATION    ${CMAKE_INSTALL_PREFIX}/lib)

# Compile GPU detector
IF ( WITH_GPU_DETECTOR )
add_definitions(-DCOMPILE_GPU=1)
ENDIF()

# Add definition for default config file
add_definitions(-DDEFAULT_CONFIG_FILE="${CMAKE_INSTALL_SYSCONFDIR}/openalpr/openalpr.conf")

=== src/tests/CMakeLists.txt ===
enable_testing()

add_definitions( -DOPENALPR_TESTING_CONFIG_PATH="${CMAKE_SOURCE_DIR}/../config/openalpr.conf.in")
add_definitions( -DOPENALPR_TESTING_RUNTIME_DIR="${CMAKE_SOURCE_DIR}/../runtime_data/")

ADD_EXECUTABLE( unittests 
  test_api.cpp 
  test_utility.cpp
  test_config.cpp
  test_regex.cpp
)

TARGET_LINK_LIBRARIES(unittests

	openalpr

  )

add_test(unittests unittests)

add_custom_target(check COMMAND ${CMAKE_CTEST_COMMAND})

=== src/video/CMakeLists.txt ===


set(video_source_files
 videobuffer.cpp

)

add_library(video STATIC ${video_source_files})

  TARGET_LINK_LIBRARIES(video
	  support
    )

#SET_TARGET_PROPERTIES( video PROPERTIES COMPILE_FLAGS -fPIC)

=== debian/changelog ===
openalpr (2.2.4-1build1) xenial; urgency=medium

  * No-change rebuild against libtesseract3

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sat, 09 Apr 2016 00:29:25 +0000

openalpr (2.2.4-1) unstable; urgency=low

  * Added Python3 bindings (Closes: #815961)
  * Remove frame number from JSON output (Closes: #813290)
  * Use dh-python to generate proper depends for python-openalpr (Closes:
    #815960)
  * Change python-openalpr from arch any to arch all (Closes: #815959)
  * Fixed build failure on Hurd (Closes: #812738)
  * Add bindings package for python3, python3-openalpr
  * Upload sponsored by Petter Reinholdtsen

 -- Matthew Hill <matthill@openalpr.com>  Sun, 28 Feb 2016 09:51:25 -0500

openalpr (2.2.3-1) unstable; urgency=low

  * Changed Debian config to build on all architectures (Closes: #812176)
  * Upload sponsored by Petter Reinholdtsen

 -- Matthew Hill <matthill@openalpr.com>  Sun, 24 Jan 2016 15:33:25 -0500

openalpr (2.2.2-1) unstable; urgency=low

  * Minor bug fixes
  * Upload sponsored by Petter Reinholdtsen

 -- Matthew Hill <matthill@openalpr.com>  Wed, 6 Jan 2016 06:48:05 -0500

openalpr (2.2.1-1) unstable; urgency=low

  * Initial upload to Debian (Closes: #747509)
  * Debian Packaging enhancements
  * Added binding for Go
  * Upload sponsored by Petter Reinholdtsen

 -- Matthew Hill <matthill@openalpr.com>  Thu, 17 Dec 2015 18:10:05 -0500

openalpr (2.2.0-0.1) experimental; urgency=low

  * Non-maintainer upload
  * Added training data for Singapore and Great Britain
  * Improved accuracy and reduced false positives for US plate detector
  * Improved support for 2-line plates (requires training data)
  * Supports analyzing multiple training datasets in one pass
  * Added OpenCL GPU support (works with Nvidia, AMD, and Intel GPUs)
  * Upgraded to OpenCV 3.0
  * Support Tesseract 3.04
  * .NET library API improvements
  * Bug Fixes

 -- Matthew Hill <matthill@openalpr.com>  Mon, 19 Oct 2015 18:15:00 -0500

openalpr (2.1.0-0.1) experimental; urgency=low

  * Non-maintainer upload
  * Added per-character details to API output
  * Bug fixes
  * Added camera calibration utility
  * Motion detector for video frames
  * Full UTF-8 character support
  * Support for South Korean and Australian plates
  * Experimental morphological plate detector
  * Pattern matching for European countries

 -- Matthew Hill <matthill@openalpr.com>  Thu, 18 Jun 2015 20:31:00 -0500

openalpr (2.0.1-0.1) experimental; urgency=low

  * Non-maintainer upload
  * Bindings for Java, C#, and Python
  * API changes/simplification
  * CUDA support
  * Bug fixes
  * Faster initial load time
  * Additional Config options
  * Library supports multi-line plates

 -- Matthew Hill <matthill@openalpr.com>  Thu, 12 Mar 2015 23:46:00 -0500

openalpr (2.0.0-0.1) experimental; urgency=low

  * Non-maintainer upload
  * Upstream release with several fixes:
    - Compilation of utilities enabled
    - installation of static library
    - alpr build against shared library

 -- Emmanuel Papin <manupap01@gmail.com>  Sun, 14 Dec 2014 19:39:07 +0200

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#DH_VERBOSE = 1

# see EXAMPLES in dpkg-buildflags(1) and read /usr/share/dpkg/*
# DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk
#

# These are used to get the most recent version of the original sources from github
UURL = $(shell git config --get remote.origin.url)
BRANCH = $(shell git rev-parse --abbrev-ref HEAD)
HEAD = $(shell git rev-parse HEAD)
PKD  = $(shell pwd)/debian
PKG  = $(word 2,$(shell dpkg-parsechangelog -l$(PKD)/changelog | grep ^Source))
VER ?= $(shell dpkg-parsechangelog -l$(PKD)/changelog | perl -ne 'print $$1 if m{^Version:\s+(?:\d+:)?(\d.*)(?:\-\d+.*)};')
DTYPE =
TARBALL = ../$(PKG)_$(VER)$(DTYPE).orig.tar.xz

# see FEATURE AREAS in dpkg-buildflags(1)
#export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

# main packaging script based on dh7 syntax
%:
	dh $@ --sourcedirectory=src --with quilt,python2,python3

override_dh_auto_configure:
	dh_auto_configure -- \
	  -DCMAKE_INSTALL_PREFIX=/usr \
	  -DCMAKE_INSTALL_SYSCONFDIR=/etc \
	  -DCMAKE_VERBOSE_MAKEFILE=OFF \
	  -DCMAKE_COLOR_MAKEFILE=ON

override_dh_auto_install:
	dh_auto_install
	cd $(CURDIR)/src/bindings/python ; python3 ./setup.py install --install-layout=deb --root $(CURDIR)/debian/python3-openalpr

override_dh_auto_clean:
	dh_auto_clean
	rm -rf $(CURDIR)/src/bindings/python/build

# Inspired by https://wiki.debian.org/onlyjob/get-orig-source
.PHONY: get-orig-source
get-orig-source: $(TARBALL) $(info I: $(PKG)_$(VER)$(DTYPE))
	@

$(TARBALL):
	$(if $(wildcard $(PKG)-$(VER)),$(error folder '$(PKG)-$(VER)' exists, aborting...))
	@echo "# Cloning origin repository..."; \
	if ! git clone $(UURL) $(PKG)-$(VER); then \
	  $(RM) -r $(PKG)-$(VER); \
	  echo "failed to clone repository, aborting..."; \
	  false; \
	fi
	@if [ $(BRANCH) != "master" ]; then \
	  cd $(PKG)-$(VER); \
	  echo "# Not on master branch, fetching origin branch '$(BRANCH)'..."; \
	  git fetch origin $(BRANCH):$(BRANCH) || false; \
	  echo "# Switching to branch '$(BRANCH)'..."; \
	  git checkout $(BRANCH) || false; \
	fi
	@echo "# Checking local source..."
	@if [ $$(cd $(PKG)-$(VER) && git rev-parse HEAD) = $(HEAD) ]; then \
	  echo "even with origin, ok"; \
	  true; \
	else \
	  echo "not even with origin, aborting..."; \
	  false; \
	fi
	@echo "# Setting times..."
	@cd $(PKG)-$(VER) \
	&& for F in $$(git ls-tree -r --name-only HEAD | sed -e "s/\s/\*/g"); do \
	  touch --no-dereference -d "$$(git log -1 --format="%ai" -- $$F)" "$$F"; \
	done
	@echo "# Cleaning-up..."
	cd $(PKG)-$(VER) && $(RM) -r .git
	@echo "# Packing file '$(TARBALL)'..."
	@find -L "$(PKG)-$(VER)" -xdev -type f -print | sort \
	| XZ_OPT="-6v" tar -caf "$(TARBALL)" -T- --owner=root --group=root --mode=a+rX \
	&& $(RM) -r "$(PKG)-$(VER)"

## openalpr 2.3.0

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -1,12 +1,14 @@
 project(src)
 
+set(CMAKE_BUILD_TYPE RelWithDebugInfo)
 #set(CMAKE_BUILD_TYPE Debug)
+
 cmake_minimum_required (VERSION 2.6)
 
 # Set the OpenALPR version in cmake, and also add it as a DEFINE for the code to access
 SET(OPENALPR_MAJOR_VERSION "2")
-SET(OPENALPR_MINOR_VERSION "2")
-SET(OPENALPR_PATCH_VERSION "4")
+SET(OPENALPR_MINOR_VERSION "3")
+SET(OPENALPR_PATCH_VERSION "0")
 SET(OPENALPR_VERSION ${OPENALPR_MAJOR_VERSION}.${OPENALPR_MINOR_VERSION}.${OPENALPR_PATCH_VERSION})
 
 add_definitions( -DOPENALPR_MAJOR_VERSION=${OPENALPR_MAJOR_VERSION})
@@ -15,6 +17,8 @@
 
 SET(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake_modules/")
 
+add_definitions( -DINSTALL_PREFIX="${CMAKE_INSTALL_PREFIX}")
+
 # TODO: switch to http://www.cmake.org/cmake/help/v2.8.5/cmake.html#module:GNUInstallDirs ?
 IF (NOT CMAKE_INSTALL_SYSCONFDIR) 
   SET(CMAKE_INSTALL_SYSCONFDIR "/etc")
@@ -28,7 +32,7 @@
 ENDIF()
 
 IF ( NOT DEFINED WITH_STATEDETECTION )
-  SET(WITH_STATEDETECTION ON)
+  SET(WITH_STATEDETECTION OFF)
 ENDIF()
 
 if ( NOT DEFINED WITH_GPU_DETECTOR )
@@ -58,6 +62,11 @@
 IF (WIN32 AND WITH_DAEMON) 
   MESSAGE(WARNING "Skipping alprd daemon installation, as it is not supported in Windows.")
   SET(WITH_DAEMON OFF)
+ENDIF()
+
+IF (WIN32 AND WITH_TESTS) 
+  MESSAGE(WARNING "Skipping unit tests, as it is not supported in Windows.")
+  SET(WITH_TESTS OFF)
 ENDIF()
 
 IF(Tesseract_FRAMEWORK_PATH AND Leptonica_FRAMEWORK_PATH) 
@@ -154,7 +163,12 @@
 
 # Compile the alprd library on Unix-based OS
 IF (WITH_DAEMON)
-  ADD_EXECUTABLE( alprd  daemon.cpp daemon/beanstalk.c daemon/beanstalk.cc )
+  ADD_EXECUTABLE( alprd  
+    daemon.cpp 
+    daemon/daemonconfig.cpp 
+    daemon/beanstalk.c 
+    daemon/beanstalk.cc 
+)
 
   FIND_PACKAGE( log4cplus REQUIRED )
 
@@ -203,12 +217,20 @@
 install (DIRECTORY  ${CMAKE_SOURCE_DIR}/../runtime_data DESTINATION         ${CMAKE_INSTALL_PREFIX}/share/openalpr)
 
 # set runtime_data to reflect the current CMAKE_INSTALL_PREFIX
-CONFIGURE_FILE(${CMAKE_SOURCE_DIR}/../config/openalpr.conf.in ${CMAKE_CURRENT_BINARY_DIR}/config/openalpr.conf)
+CONFIGURE_FILE(${CMAKE_SOURCE_DIR}/../config/openalpr.conf.user ${CMAKE_CURRENT_BINARY_DIR}/config/openalpr.conf)
 install (FILES      ${CMAKE_CURRENT_BINARY_DIR}/config/openalpr.conf DESTINATION ${CMAKE_INSTALL_SYSCONFDIR}/openalpr/      COMPONENT config)
 
+CONFIGURE_FILE(${CMAKE_SOURCE_DIR}/../config/openalpr.conf.defaults ${CMAKE_CURRENT_BINARY_DIR}/share/openalpr/config/openalpr.defaults.conf)
+install (FILES      ${CMAKE_CURRENT_BINARY_DIR}/share/openalpr/config/openalpr.defaults.conf DESTINATION ${CMAKE_INSTALL_PREFIX}/share/openalpr/config      COMPONENT config)
+
 IF (WITH_DAEMON)
+  CONFIGURE_FILE(${CMAKE_SOURCE_DIR}/../config/alprd.conf.user ${CMAKE_CURRENT_BINARY_DIR}/config/alprd.conf)
+  install (FILES      ${CMAKE_CURRENT_BINARY_DIR}/config/alprd.conf DESTINATION ${CMAKE_INSTALL_SYSCONFDIR}/openalpr/      COMPONENT config)
+
+  CONFIGURE_FILE(${CMAKE_SOURCE_DIR}/../config/alprd.conf.defaults ${CMAKE_CURRENT_BINARY_DIR}/share/openalpr/config/alprd.defaults.conf)
+  install (FILES      ${CMAKE_CURRENT_BINARY_DIR}/share/openalpr/config/alprd.defaults.conf DESTINATION ${CMAKE_INSTALL_PREFIX}/share/openalpr/config      COMPONENT config)
+
   install (TARGETS    alprd DESTINATION  ${CMAKE_INSTALL_PREFIX}/bin)
-  install (FILES      ${CMAKE_SOURCE_DIR}/../config/alprd.conf DESTINATION    ${CMAKE_INSTALL_SYSCONFDIR}/openalpr      COMPONENT config)
 ENDIF()

=== src/misc_utilities/CMakeLists.txt ===

ADD_EXECUTABLE( openalpr-utils-sortstate sortstate.cpp  )
TARGET_LINK_LIBRARIES(openalpr-utils-sortstate
    ${OPENALPR_LIB}
	${STATE_DETECTION_LIB}
    support
    ${OpenCV_LIBS} 
	${Tesseract_LIBRARIES}
  )
  
ADD_EXECUTABLE( openalpr-utils-classifychars classifychars.cpp )
TARGET_LINK_LIBRARIES(openalpr-utils-classifychars
    ${OPENALPR_LIB}
    support
    ${OpenCV_LIBS} 
	${Tesseract_LIBRARIES}
  )
  
if (NOT DEFINED WIN32)
ADD_EXECUTABLE(openalpr-utils-benchmark
		benchmarks/benchmark.cpp 
		benchmarks/benchmark_utils.cpp 
		benchmarks/endtoendtest.cpp 
)
TARGET_LINK_LIBRARIES(openalpr-utils-benchmark
    ${OPENALPR_LIB}
    ${STATE_DETECTION_LIB}
    support
    pthread
    ${OpenCV_LIBS} 
	${Tesseract_LIBRARIES}
  )
ENDIF()
  
ADD_EXECUTABLE( openalpr-utils-prepcharsfortraining prepcharsfortraining.cpp )
TARGET_LINK_LIBRARIES(openalpr-utils-prepcharsfortraining
    support
    ${OpenCV_LIBS} 
  )
 
ADD_EXECUTABLE( openalpr-utils-binarizefontsheet binarizefontsheet.cpp )
TARGET_LINK_LIBRARIES(openalpr-utils-binarizefontsheet
    ${OPENALPR_LIB}
    support
    ${OpenCV_LIBS} 
  ) 
  
ADD_EXECUTABLE( openalpr-utils-tagplates tagplates.cpp )
TARGET_LINK_LIBRARIES(openalpr-utils-tagplates
    ${OPENALPR_LIB}
    support
    ${OpenCV_LIBS} 
  )
  
ADD_EXECUTABLE( openalpr-utils-calibrate calibrate.cpp  )
TARGET_LINK_LIBRARIES(openalpr-utils-calibrate
    ${OPENALPR_LIB}
    support
    ${OpenCV_LIBS} 
	${Tesseract_LIBRARIES}
  )

  
install (TARGETS openalpr-utils-calibrate DESTINATION bin)


install (TARGETS openalpr-utils-classifychars DESTINATION bin)

if (NOT DEFINED WIN32)
install (TARGETS openalpr-utils-benchmark DESTINATION bin)
ENDIF()

install (TARGETS openalpr-utils-prepcharsfortraining DESTINATION bin)
install (TARGETS openalpr-utils-tagplates DESTINATION bin)
install (TARGETS openalpr-utils-calibrate DESTINATION bin)

=== src/openalpr/CMakeLists.txt ===
--- 
+++ 
@@ -5,22 +5,26 @@
  alpr.cpp
  alpr_impl.cpp
  config.cpp
+ config_helper.cpp
  detection/detector.cpp
  detection/detectorcpu.cpp
  detection/detectorcuda.cpp
  detection/detectorocl.cpp
  detection/detectorfactory.cpp
  detection/detectormorph.cpp
+ detection/detectormask.cpp
  licenseplatecandidate.cpp
  utility.cpp
- ocr.cpp
+ ocr/tesseract_ocr.cpp
+ ocr/ocr.cpp
+ ocr/ocrfactory.cpp
  postprocess/postprocess.cpp
  postprocess/regexrule.cpp
  binarize_wolf.cpp
- segmentation/charactersegmenter.cpp
- segmentation/histogram.cpp
- segmentation/histogramvertical.cpp
- segmentation/histogramhorizontal.cpp
+ ocr/segmentation/charactersegmenter.cpp
+ ocr/segmentation/histogram.cpp
+ ocr/segmentation/histogramvertical.cpp
+ ocr/segmentation/histogramhorizontal.cpp
  edges/edgefinder.cpp
  edges/platecorners.cpp
  edges/platelines.cpp

=== src/statedetection/CMakeLists.txt ===



set(statedetector_source_files
  state_detector.cpp
  featurematcher.cpp
  line_segment.cpp
  state_detector_impl.cpp
)

if (WIN32 OR IOS) 
	add_library(statedetection 		STATIC ${statedetector_source_files} )
ELSE()
	add_library(statedetection 		SHARED ${statedetector_source_files} )
ENDIF()

set_target_properties(statedetection PROPERTIES SOVERSION ${OPENALPR_MAJOR_VERSION})

TARGET_LINK_LIBRARIES(statedetection
   ${OpenCV_LIBS}
   support
)


install (FILES   state_detector.h     DESTINATION    ${CMAKE_INSTALL_PREFIX}/include)
install (TARGETS statedetection   DESTINATION    ${CMAKE_INSTALL_PREFIX}/lib)

=== src/tests/CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 enable_testing()
 
-add_definitions( -DOPENALPR_TESTING_CONFIG_PATH="${CMAKE_SOURCE_DIR}/../config/openalpr.conf.in")
+add_definitions( -DOPENALPR_TESTING_CONFIG_PATH="${CMAKE_SOURCE_DIR}/../config/openalpr.conf.defaults")
 add_definitions( -DOPENALPR_TESTING_RUNTIME_DIR="${CMAKE_SOURCE_DIR}/../runtime_data/")
 
 ADD_EXECUTABLE( unittests

=== src/bindings/go/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.6)

set(go_source_files
  openalprgo.cpp
)

add_library(openalprgo SHARED ${go_source_files})

set_target_properties(openalprgo PROPERTIES SOVERSION ${OPENALPR_MAJOR_VERSION})

TARGET_LINK_LIBRARIES(openalprgo openalpr)

if (NOT WIN32)
    #generate the .pc file
    SET(prefix "${CMAKE_INSTALL_PREFIX}")
    SET(exec_prefix "\${prefix}")
    SET(libdir "\${exec_prefix}/lib")
    SET(includedir "\${exec_prefix}/include")
    SET(VERSION "${OPENALPR_VERSION}")
    CONFIGURE_FILE(
      "${CMAKE_MODULE_PATH}/templates/openalpr.pc.in"
      "${CMAKE_CURRENT_BINARY_DIR}/pkgconfig/openalpr.pc"
      @ONLY)
    install (FILES "${CMAKE_CURRENT_BINARY_DIR}/pkgconfig/openalpr.pc" DESTINATION "${CMAKE_INSTALL_PREFIX}/lib/pkgconfig")
ENDIF()

install (TARGETS    openalprgo       DESTINATION     ${CMAKE_INSTALL_PREFIX}/lib)
install (FILES    openalprgo.h     DESTINATION     ${CMAKE_INSTALL_PREFIX}/include)

=== src/bindings/java/CMakeLists.txt ===

cmake_minimum_required (VERSION 2.6)


find_package(JNI)

if (${JNI_FOUND} MATCHES "TRUE")
  include_directories(
    ../../openalpr/
    ${JAVA_INCLUDE_PATH}
    ${JAVA_INCLUDE_PATH2}
  )


  set(jni_source_files
   openalprjni.cpp
  )


  add_library(openalprjni SHARED ${jni_source_files})

  set_target_properties(openalprjni PROPERTIES SOVERSION ${OPENALPR_MAJOR_VERSION})

  TARGET_LINK_LIBRARIES(openalprjni openalpr)


  install (TARGETS openalprjni   DESTINATION    ${CMAKE_INSTALL_PREFIX}/lib)
else()
  MESSAGE("JAVA JNI library not found, skipping openalprjni compilation")

endif()

=== src/bindings/python/CMakeLists.txt ===

cmake_minimum_required (VERSION 2.6)


include_directories(../../openalpr/)


set(python_source_files
 openalprpy.cpp
)

    
add_library(openalprpy SHARED ${python_source_files})

set_target_properties(openalprpy PROPERTIES SOVERSION ${OPENALPR_MAJOR_VERSION})

TARGET_LINK_LIBRARIES(openalprpy openalpr)


install (TARGETS    openalprpy       DESTINATION     ${CMAKE_INSTALL_PREFIX}/lib)
install (DIRECTORY  openalpr  DESTINATION     ${CMAKE_INSTALL_PREFIX}/lib/python2.7/dist-packages
    USE_SOURCE_PERMISSIONS
)

=== src/openalpr/simpleini/CMakeLists.txt ===


set(simpleini_source_files
 ConvertUTF.c
)


add_library(simpleini ${simpleini_source_files})

=== src/openalpr/support/CMakeLists.txt ===


set(support_source_files
 filesystem.cpp
 timing.cpp
 tinythread.cpp
 platform.cpp
 utf8.cpp
 version.cpp
)

set(regex_source_files


re2/bitstate.cc
re2/compile.cc
re2/dfa.cc
re2/filtered_re2.cc
re2/mimics_pcre.cc
re2/nfa.cc
re2/onepass.cc
re2/parse.cc
re2/perl_groups.cc
re2/prefilter.cc
re2/prefilter_tree.cc
re2/prog.cc
re2/re2.cc
re2/regexp.cc
re2/set.cc
re2/simplify.cc
re2/stringpiece.cc
re2/tostring.cc
re2/unicode_casefold.cc
re2/unicode_groups.cc
re2/util/hash.cc
re2/util/stringprintf.cc
re2/util/rune.cc
re2/util/strutil.cc
re2/util/valgrind.cc

)


include_directories(.)

add_library(support STATIC 
  ${support_source_files} 
  ${regex_source_files}
)

SET_TARGET_PROPERTIES( support PROPERTIES COMPILE_FLAGS -fPIC)

=== debian/changelog ===
openalpr (2.3.0-1build4) bionic; urgency=medium

  * No-change rebuild against libcurl4

 -- Steve Langasek <steve.langasek@ubuntu.com>  Wed, 28 Feb 2018 08:38:19 +0000

openalpr (2.3.0-1build3) bionic; urgency=medium

  * No-change rebuild for tesseract soname change.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 31 Jan 2018 06:20:59 +0000

openalpr (2.3.0-1build2) bionic; urgency=medium

  * No-change rebuild against OpenCV 3.2.

 -- Mattia Rizzolo <mapreri@ubuntu.com>  Sun, 29 Oct 2017 13:00:08 +0100

openalpr (2.3.0-1build1) artful; urgency=medium

  * No-change rebuild against OpenCV 3.1.

 -- Mattia Rizzolo <mapreri@ubuntu.com>  Tue, 20 Jun 2017 14:06:06 +0200

openalpr (2.3.0-1) unstable; urgency=low

  * Added plate detection mask and prewarp config changes via API
  * Improved plate patterns
  * Improved accuracy
  * Upload sponsored by Petter Reinholdtsen

 -- Matthew Hill <matthill@openalpr.com>  Sat, 17 Sep 2016 11:27:25 -0500

=== debian/control ===
Source: openalpr
Section: video
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Matthew Hill <matthill@openalpr.com>
Build-Depends: debhelper (>= 9), cmake, quilt, 
 libtesseract-dev, libleptonica-dev, liblog4cplus-dev,
 libcurl3-dev, libopencv-dev, default-jdk,
 python, python3, dh-python
Standards-Version: 3.9.6
Homepage: https://github.com/openalpr/openalpr
Vcs-Browser: https://github.com/openalpr/openalpr
Vcs-Git: https://github.com/openalpr/openalpr.git

Package: libopenalpr2
Section: libs
Architecture: any
Depends: libopenalpr-data (= ${source:Version}), ${shlibs:Depends},
 ${misc:Depends}
Description: Automated License Plate Recognition library (OpenALPR)
 OpenALPR is an open source Automatic License Plate Recognition library written
 in C++. The library analyzes images and identifies license plates. The output
 is the text representation of any license plate characters found in the image.
 .
 This package contains the runtime libraries used to interface with OpenALPR.

Package: libopenalpr-dev
Section: libdevel
Architecture: any
Depends: libopenalpr2 (= ${binary:Version}), ${misc:Depends}
Description: Development files for the OpenALPR library
 OpenALPR is an open source Automatic License Plate Recognition library written
 in C++. The library analyzes images and identifies license plates. The output
 is the text representation of any license plate characters found in the image.
 .
 This package contains the header files and static libraries used to link
 OpenALPR into another program.

Package: libopenalpr-data
Section: misc
Architecture: all
Depends: ${misc:Depends}
Description: Runtime data for the OpenALPR library
 OpenALPR is an open source Automatic License Plate Recognition library written
 in C++. The library analyzes images and identifies license plates. The output
 is the text representation of any license plate characters found in the image.
 .
 This package contains the runtime training data used by OpenALPR to recognize
 license plates from various countries. 

Package: openalpr
Architecture: any
Depends: libopenalpr2 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: Command line program to operate the OpenALPR library
 OpenALPR is an open source Automatic License Plate Recognition library written
 in C++. The library analyzes images and identifies license plates. The output
 is the text representation of any license plate characters found in the image.
 .
 This package contains a command-line program to analyze images for license 
 plates. 

Package: openalpr-daemon
Architecture: any
Depends: libopenalpr2 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends},
 adduser,
 beanstalkd
Description: Daemon to run OpenALPR in the background
 OpenALPR is an open source Automatic License Plate Recognition library written
 in C++. The library analyzes images and identifies license plates. The output
 is the text representation of any license plate characters found in the image.
 .
 The OpenALPR daemon allows you to monitor a camera stream for license plate
 numbers in the background. Alprd runs as a daemon process on Linux.
 .
 The plate numbers can be streamed to another server (via HTTP posts) or can be
 consumed programmatically via a beanstalkd queue.

Package: openalpr-utils
Section: utils
Architecture: any
Depends: libopenalpr2 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: Utilities for the OpenALPR library
 OpenALPR is an open source Automatic License Plate Recognition library written
 in C++. The library analyzes images and identifies license plates. The output
 is the text representation of any license plate characters found in the image.
 .
 The OpenALPR utils package contains a collection of binaries that help with 
 training new data.  The following binaries are included:
 .
 openalpr-utils-calibrate - Calibrates the software for cameras capturing plate
 images at an angle
 .
 openalpr-utils-benchmark - Benchmarks accuracy/speed against a testing dataset
 .
 openalpr-utils-tagplates - Utility to tag the location and plate number for 
 testing and training
 .
 openalpr-utils-classifychars - Extracts character images from cropped plate
 images for OCR training
 .
 openalpr-utils-prepcharsfortraining - Reformates character images into a format
 that Tesseract can use for OCR training

Package: python-openalpr
Section: python
Architecture: all
Depends: libopenalpr-dev (>= ${binary:Version}), 
 ${python:Depends}, ${misc:Depends}
Description: Python binding for OpenALPR library
 OpenALPR is an open source Automatic License Plate Recognition library written
 in C++. The library analyzes images and identifies license plates. The output
 is the text representation of any license plate characters found in the image.
 .
 The Python package allows Python code to interface with OpenALPR directly via 
 native Python bindings.

Package: python3-openalpr
Section: python
Architecture: all
Depends: libopenalpr-dev (>= ${source:Version}), 
 ${python3:Depends}, ${misc:Depends}
Description: Python 3 binding for OpenALPR library
 OpenALPR is an open source Automatic License Plate Recognition library written
 in C++. The library analyzes images and identifies license plates. The output
 is the text representation of any license plate characters found in the image.
 .
 The Python 3 package allows Python 3 code to interface with OpenALPR directly 
 via native Python 3 bindings.
